// Fizzling cube
PORTAL.FizzleCube = object_add();
object_set_sprite(PORTAL.FizzleCube, PORTAL.CubeS);

object_event_add(PORTAL.FizzleCube, ev_create, 0, '
    image_speed = 0;
    lifetime = 50 / global.delta_factor;
    color = c_white;

    alarm[0] = lifetime;
    playsound(x, y, PORTAL.FizzleSnd)
');

object_event_add(PORTAL.FizzleCube, ev_alarm, 0, '
    instance_destroy();
');

object_event_add(PORTAL.FizzleCube, ev_step, ev_step_begin, '
    if (global.run_virtual_ticks == true && random(1) > 0.8) {
        execute_string(PORTAL.SpawnParticles, x, y, 90, c_yellow);
    }

    hspeed *= delta_mult(0.95);
    if (vspeed > -0.6) {
        vspeed -= 0.3 * global.delta_factor;
    } else {
        vspeed = -0.6;
    }

    x += hspeed * global.delta_factor;
    y += vspeed * global.delta_factor;
    x -= hspeed;
    y -= vspeed;

    image_alpha = (alarm[0] / lifetime) + 0.1;
    image_xscale = 1.5 - (alarm[0] / lifetime) / 2;
    image_yscale = image_xscale;

    var col;
    col = (alarm[0] / lifetime) * 255;
    color = make_color_rgb(col, col, col);
');

object_event_add(PORTAL.FizzleCube, ev_draw, 0, '
    draw_sprite_ext(sprite_index, image_index, x, y, image_xscale, image_yscale, image_angle, color, image_alpha);
');

// Use blood as portal particles.
object_event_add(BloodDrop, ev_create, 0, '
    color = c_white;
');

object_event_add(BloodDrop, ev_draw, 0, '
    draw_sprite_ext(sprite_index, image_index, x, y, image_xscale, image_yscale, image_angle, color, image_alpha);
');
